Package: sys
Type: Package
Title: Powerful and Reliable Tools for Running System Commands in R
Version: 3.4.1
Authors@R: c(person("Jeroen", "Ooms", role = c("aut", "cre"), 
      email = "jeroen@berkeley.edu", comment = c(ORCID = "0000-0002-4035-0289")),
    person("Gábor", "Csárdi", , "csardi.gabor@gmail.com", role = "ctb"))
Description: Drop-in replacements for the base system2() function with fine control
    and consistent behavior across platforms. Supports clean interruption, timeout, 
    background tasks, and streaming STDIN / STDOUT / STDERR over binary or text 
    connections. Arguments on Windows automatically get encoded and quoted to work 
    on different locales.
License: MIT + file LICENSE
URL: https://github.com/jeroen/sys
BugReports: https://github.com/jeroen/sys/issues
Encoding: UTF-8
RoxygenNote: 7.1.1
Suggests: unix (>= 1.4), spelling, testthat
Language: en-US
NeedsCompilation: yes
Packaged: 2022-10-18 09:37:11 UTC; jeroen
Author: Jeroen Ooms [aut, cre] (<https://orcid.org/0000-0002-4035-0289>),
  Gábor Csárdi [ctb]
Maintainer: Jeroen Ooms <jeroen@berkeley.edu>
Repository: CRAN
Date/Publication: 2022-10-18 12:40:02 UTC

#' Quote arguments on Windows
#'
#' Quotes and escapes shell arguments when needed so that they get properly parsed
#' by most Windows programs. This function is used internally to automatically quote
#' system commands, the user should normally not quote arguments manually.
#'
#' Algorithm is ported to R from
#' [libuv](https://github.com/libuv/libuv/blob/v1.23.0/src/win/process.c#L454-L524).
#'
#' @export
#' @rdname quote
#' @name quote
#' @param args character vector with arguments
windows_quote <- function(args){
  if(is.null(args))
    return(args)
  stopifnot(is.character(args))
  args <- enc2utf8(args)
  vapply(args, windows_quote_one, character(1), USE.NAMES = FALSE)
}

windows_quote_one <- function(str){
  if(!nchar(str)){
    return('""')
  }
  if(!grepl('[ \t"]', str)){
    return(str)
  }
  if(!grepl('["\\]', str)){
    return(paste0('"', str, '"'))
  }
  str <- gsub('([\\]*)"', '\\1\\1\\\\"', str, useBytes = TRUE)
  str <- gsub('([\\]+)$', '\\1\\1', str, useBytes = TRUE)
  paste0('"', str, '"')
}

#' Deprecated functions
#'
#' These functions have moved into the `unix` package. Please update
#' your references.
#'
#' @export
#' @name sys-deprecated
#' @rdname deprecated
#' @param ... see respective functions in the unix package
eval_safe <- function(...){
  .Deprecated('unix::eval_safe', 'sys')
  unix::eval_safe(...)
}

#' @export
#' @rdname deprecated
eval_fork <- function(...){
  .Deprecated('unix::eval_fork', 'sys')
  unix::eval_fork(...)
}

#' Running System Commands
#'
#' Powerful replacements for [system2] with support for interruptions, background
#' tasks and fine grained control over `STDOUT` / `STDERR` binary or text streams.
#'
#' Each value within the `args` vector will automatically be quoted when needed;
#' you should not quote arguments yourself. Doing so anyway could lead to the value
#' being quoted twice on some platforms.
#'
#' The `exec_wait` function runs a system command and waits for the child process
#' to exit. When the child process completes normally (either success or error) it
#' returns with the program exit code. Otherwise (if the child process gets aborted)
#' R raises an error. The R user can interrupt the program by sending SIGINT (press
#' ESC or CTRL+C) in which case the child process tree is properly terminated.
#' Output streams `STDOUT` and `STDERR` are piped back to the parent process and can
#' be sent to a connection or callback function. See the section on *Output Streams*
#' below for details.
#'
#' The `exec_background` function starts the program and immediately returns the
#' PID of the child process. This is useful for running a server daemon or background
#' process.
#' Because this is non-blocking, `std_out` and `std_out` can only be `TRUE`/`FALSE` or
#' a file path. The state of the process can be checked with `exec_status` which
#' returns the exit status, or `NA` if the process is still running. If `wait = TRUE`
#' then `exec_status` blocks until the process completes (but can be interrupted).
#' The child can be killed with [tools::pskill].
#'
#' The `exec_internal` function is a convenience wrapper around `exec_wait` which
#' automatically captures output streams and raises an error if execution fails.
#' Upon success it returns a list with status code, and raw vectors containing
#' stdout and stderr data (use [as_text] for converting to text).
#'
#' @section Output Streams:
#'
#' The `std_out` and `std_err` parameters are used to control how output streams
#' of the child are processed. Possible values for both foreground and background
#' processes are:
#'
#'  - `TRUE`: print child output in R console
#'  - `FALSE`: suppress output stream
#'  - *string*: name or path of file to redirect output
#'
#' In addition the `exec_wait` function also supports the following `std_out` and `std_err`
#' types:
#'
#'  - *connection* a writable R [connection] object such as [stdout] or [stderr]
#'  - *function*: callback function with one argument accepting a raw vector (use
#'  [as_text] to convert to text).
#'
#' When using `exec_background` with `std_out = TRUE` or `std_err = TRUE` on Windows,
#' separate threads are used to print output. This works in RStudio and RTerm but
#' not in RGui because the latter has a custom I/O mechanism. Directing output to a
#' file is usually the safest option.
#'
#' @export
#' @return `exec_background` returns a pid. `exec_wait` returns an exit code.
#' `exec_internal` returns a list with exit code, stdout and stderr strings.
#' @name exec
#' @aliases sys
#' @seealso Base [system2] and [pipe] provide other methods for running a system
#' command with output.
#' @family sys
#' @rdname exec
#' @param cmd the command to run. Either a full path or the name of a program on
#' the `PATH`. On Windows this is automatically converted to a short path using
#' [Sys.which], unless wrapped in [I()].
#' @param args character vector of arguments to pass. On Windows these automatically
#' get quoted using [windows_quote], unless the value is wrapped in [I()].
#' @param std_out if and where to direct child process `STDOUT`. Must be one of
#' `TRUE`, `FALSE`, filename, connection object or callback function. See section
#' on *Output Streams* below for details.
#' @param std_err if and where to direct child process `STDERR`. Must be one of
#' `TRUE`, `FALSE`, filename, connection object or callback function. See section
#' on *Output Streams* below for details.
#' @param std_in file path to map std_in
#' @param timeout maximum time in seconds
#' @examples # Run a command (interrupt with CTRL+C)
#' status <- exec_wait("date")
#'
#' # Capture std/out
#' out <- exec_internal("date")
#' print(out$status)
#' cat(as_text(out$stdout))
#'
#' if(nchar(Sys.which("ping"))){
#'
#' # Run a background process (daemon)
#' pid <- exec_background("ping", "localhost")
#'
#' # Kill it after a while
#' Sys.sleep(2)
#' tools::pskill(pid)
#'
#' # Cleans up the zombie proc
#' exec_status(pid)
#' rm(pid)
#' }
exec_wait <- function(cmd, args = NULL, std_out = stdout(), std_err = stderr(), std_in = NULL, timeout = 0){
  # Convert TRUE or filepath into connection objects
  std_out <- if(isTRUE(std_out) || identical(std_out, "")){
    stdout()
  } else if(is.character(std_out)){
    file(normalizePath(std_out, mustWork = FALSE))
  } else std_out

  std_err <- if(isTRUE(std_err) || identical(std_err, "")){
    stderr()
  } else if(is.character(std_err)){
    std_err <- file(normalizePath(std_err, mustWork = FALSE))
  } else std_err

  # Define the callbacks
  outfun <- if(inherits(std_out, "connection")){
    if(!isOpen(std_out)){
      open(std_out, "wb")
      on.exit(close(std_out), add = TRUE)
    }
    if(identical(summary(std_out)$text, "text")){
      function(x){
        cat(rawToChar(x), file = std_out)
        flush(std_out)
      }
    } else {
      function(x){
        writeBin(x, con = std_out)
        flush(std_out)
      }
    }
  } else if(is.function(std_out)){
    if(!length(formals(std_out)))
      stop("Function std_out must take at least one argument")
    std_out
  }

  errfun <- if(inherits(std_err, "connection")){
    if(!isOpen(std_err)){
      open(std_err, "wb")
      on.exit(close(std_err), add = TRUE)
    }
    if(identical(summary(std_err)$text, "text")){
      function(x){
        cat(rawToChar(x), file = std_err)
        flush(std_err)
      }
    } else {
      function(x){
        writeBin(x, con = std_err)
        flush(std_err)
      }
    }
  } else if(is.function(std_err)){
    if(!length(formals(std_err)))
      stop("Function std_err must take at least one argument")
    std_err
  }
  execute(cmd = cmd, args = args, std_out = outfun, std_err = errfun,
          std_in = std_in, wait = TRUE, timeout = timeout)
}

#' @export
#' @rdname exec
exec_background <- function(cmd, args = NULL, std_out = TRUE, std_err = TRUE, std_in = NULL){
  if(!is.character(std_out) && !is.logical(std_out))
    stop("argument 'std_out' must be TRUE / FALSE or a filename")
  if(!is.character(std_err) && !is.logical(std_err))
    stop("argument 'std_err' must be TRUE / FALSE or a filename")
  execute(cmd = cmd, args = args, std_out = std_out, std_err = std_err,
          wait = FALSE, std_in = std_in, timeout = 0)
}

#' @export
#' @rdname exec
#' @param error automatically raise an error if the exit status is non-zero.
exec_internal <- function(cmd, args = NULL, std_in = NULL, error = TRUE, timeout = 0){
  outcon <- rawConnection(raw(0), "r+")
  on.exit(close(outcon), add = TRUE)
  errcon <- rawConnection(raw(0), "r+")
  on.exit(close(errcon), add = TRUE)
  status <- exec_wait(cmd, args, std_out = outcon,
                      std_err = errcon, std_in = std_in, timeout = timeout)
  if(isTRUE(error) && !identical(status, 0L))
    stop(sprintf("Executing '%s' failed with status %d", cmd, status))
  list(
    status = status,
    stdout = rawConnectionValue(outcon),
    stderr = rawConnectionValue(errcon)
  )
}

#' @export
#' @rdname exec
#' @useDynLib sys R_exec_status
#' @param pid integer with a process ID
#' @param wait block until the process completes
exec_status <- function(pid, wait = TRUE){
  .Call(R_exec_status, pid, wait)
}

#' @useDynLib sys C_execute
execute <- function(cmd, args, std_out, std_err, std_in, wait, timeout){
  stopifnot(is.character(cmd))
  if(.Platform$OS.type == 'windows'){
    if(!inherits(cmd, 'AsIs'))
      cmd <- utils::shortPathName(path.expand(cmd))
    if(!inherits(args, 'AsIs'))
      args <- windows_quote(args)
  } else {
    if(!inherits(cmd, 'AsIs'))
      cmd <- path.expand(cmd)
  }
  stopifnot(is.logical(wait))
  argv <- enc2utf8(c(cmd, args))
  if(length(std_in) && !is.logical(std_in)) # Only files supported for stdin
    std_in <- enc2utf8(normalizePath(std_in, mustWork = TRUE))
  .Call(C_execute, cmd, argv, std_out, std_err, std_in, wait, timeout)
}

#' Execute R from R
#'
#' Convenience wrappers for [exec_wait] and [exec_internal] that shell out to
#' R itself: `R.home("bin/R")`.
#'
#' This is a simple but robust way to invoke R commands in a separate process.
#' Use the [callr](https://cran.r-project.org/package=callr) package if you
#' need more sophisticated control over (multiple) R process jobs.
#'
#' @export
#' @rdname exec_r
#' @name exec_r
#' @family sys
#' @inheritParams exec
#' @param args command line arguments for R
#' @param std_in a file to send to stdin, usually an R script (see examples).
#' @examples # Hello world
#' r_wait("--version")
#'
#' # Run some code
#' r_wait(c('--vanilla', '-q', '-e', 'sessionInfo()'))
#'
#' # Run a script via stdin
#' tmp <- tempfile()
#' writeLines(c("x <- rnorm(100)", "mean(x)"), con = tmp)
#' r_wait(std_in = tmp)
r_wait <- function(args = '--vanilla', std_out = stdout(), std_err = stderr(), std_in = NULL){
  exec_wait(rbin(), args = args, std_out = std_out, std_err = std_err, std_in = std_in)
}

#' @export
#' @rdname exec_r
r_internal <- function(args = '--vanilla', std_in = NULL, error = TRUE){
  exec_internal(rbin(), args = args, std_in = std_in, error = error)
}

#' @export
#' @rdname exec_r
r_background <- function(args = '--vanilla', std_out = TRUE, std_err = TRUE, std_in = NULL){
  exec_background(rbin(), args = args, std_out = std_out, std_err = std_err, std_in = std_in)
}

rbin <- function(){
  cmd <- ifelse(.Platform$OS.type == 'windows', 'Rterm', 'R')
  file.path(R.home('bin'), cmd)
}

#' Convert Raw to Text
#'
#' Parses a raw vector as lines of text. This is similar to [charToRaw] but
#' splits output by (platform specific) linebreaks and allows for marking
#' output with a given encoding.
#'
#'
#' @export
#' @seealso [base::charToRaw]
#' @param x vector to be converted to text
#' @param ... parameters passed to [readLines] such as `encoding` or `n`
as_text <- function(x, ...){
  if(length(x)){
    con <- rawConnection(x)
    on.exit(close(con))
    readLines(con, ...)
  } else {
    character(0)
  }
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/callr.R
\name{exec_r}
\alias{exec_r}
\alias{r_wait}
\alias{r_internal}
\alias{r_background}
\title{Execute R from R}
\usage{
r_wait(
  args = "--vanilla",
  std_out = stdout(),
  std_err = stderr(),
  std_in = NULL
)

r_internal(args = "--vanilla", std_in = NULL, error = TRUE)

r_background(args = "--vanilla", std_out = TRUE, std_err = TRUE, std_in = NULL)
}
\arguments{
\item{args}{command line arguments for R}

\item{std_out}{if and where to direct child process \code{STDOUT}. Must be one of
\code{TRUE}, \code{FALSE}, filename, connection object or callback function. See section
on \emph{Output Streams} below for details.}

\item{std_err}{if and where to direct child process \code{STDERR}. Must be one of
\code{TRUE}, \code{FALSE}, filename, connection object or callback function. See section
on \emph{Output Streams} below for details.}

\item{std_in}{a file to send to stdin, usually an R script (see examples).}

\item{error}{automatically raise an error if the exit status is non-zero.}
}
\description{
Convenience wrappers for \link{exec_wait} and \link{exec_internal} that shell out to
R itself: \code{R.home("bin/R")}.
}
\details{
This is a simple but robust way to invoke R commands in a separate process.
Use the \href{https://cran.r-project.org/package=callr}{callr} package if you
need more sophisticated control over (multiple) R process jobs.
}
\examples{
# Hello world
r_wait("--version")

# Run some code
r_wait(c('--vanilla', '-q', '-e', 'sessionInfo()'))

# Run a script via stdin
tmp <- tempfile()
writeLines(c("x <- rnorm(100)", "mean(x)"), con = tmp)
r_wait(std_in = tmp)
}
\seealso{
Other sys: 
\code{\link{exec}}
}
\concept{sys}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exec.R
\name{exec}
\alias{exec}
\alias{exec_wait}
\alias{sys}
\alias{exec_background}
\alias{exec_internal}
\alias{exec_status}
\title{Running System Commands}
\usage{
exec_wait(
  cmd,
  args = NULL,
  std_out = stdout(),
  std_err = stderr(),
  std_in = NULL,
  timeout = 0
)

exec_background(
  cmd,
  args = NULL,
  std_out = TRUE,
  std_err = TRUE,
  std_in = NULL
)

exec_internal(cmd, args = NULL, std_in = NULL, error = TRUE, timeout = 0)

exec_status(pid, wait = TRUE)
}
\arguments{
\item{cmd}{the command to run. Either a full path or the name of a program on
the \code{PATH}. On Windows this is automatically converted to a short path using
\link{Sys.which}, unless wrapped in \code{\link[=I]{I()}}.}

\item{args}{character vector of arguments to pass. On Windows these automatically
get quoted using \link{windows_quote}, unless the value is wrapped in \code{\link[=I]{I()}}.}

\item{std_out}{if and where to direct child process \code{STDOUT}. Must be one of
\code{TRUE}, \code{FALSE}, filename, connection object or callback function. See section
on \emph{Output Streams} below for details.}

\item{std_err}{if and where to direct child process \code{STDERR}. Must be one of
\code{TRUE}, \code{FALSE}, filename, connection object or callback function. See section
on \emph{Output Streams} below for details.}

\item{std_in}{file path to map std_in}

\item{timeout}{maximum time in seconds}

\item{error}{automatically raise an error if the exit status is non-zero.}

\item{pid}{integer with a process ID}

\item{wait}{block until the process completes}
}
\value{
\code{exec_background} returns a pid. \code{exec_wait} returns an exit code.
\code{exec_internal} returns a list with exit code, stdout and stderr strings.
}
\description{
Powerful replacements for \link{system2} with support for interruptions, background
tasks and fine grained control over \code{STDOUT} / \code{STDERR} binary or text streams.
}
\details{
Each value within the \code{args} vector will automatically be quoted when needed;
you should not quote arguments yourself. Doing so anyway could lead to the value
being quoted twice on some platforms.

The \code{exec_wait} function runs a system command and waits for the child process
to exit. When the child process completes normally (either success or error) it
returns with the program exit code. Otherwise (if the child process gets aborted)
R raises an error. The R user can interrupt the program by sending SIGINT (press
ESC or CTRL+C) in which case the child process tree is properly terminated.
Output streams \code{STDOUT} and \code{STDERR} are piped back to the parent process and can
be sent to a connection or callback function. See the section on \emph{Output Streams}
below for details.

The \code{exec_background} function starts the program and immediately returns the
PID of the child process. This is useful for running a server daemon or background
process.
Because this is non-blocking, \code{std_out} and \code{std_out} can only be \code{TRUE}/\code{FALSE} or
a file path. The state of the process can be checked with \code{exec_status} which
returns the exit status, or \code{NA} if the process is still running. If \code{wait = TRUE}
then \code{exec_status} blocks until the process completes (but can be interrupted).
The child can be killed with \link[tools:pskill]{tools::pskill}.

The \code{exec_internal} function is a convenience wrapper around \code{exec_wait} which
automatically captures output streams and raises an error if execution fails.
Upon success it returns a list with status code, and raw vectors containing
stdout and stderr data (use \link{as_text} for converting to text).
}
\section{Output Streams}{


The \code{std_out} and \code{std_err} parameters are used to control how output streams
of the child are processed. Possible values for both foreground and background
processes are:
\itemize{
\item \code{TRUE}: print child output in R console
\item \code{FALSE}: suppress output stream
\item \emph{string}: name or path of file to redirect output
}

In addition the \code{exec_wait} function also supports the following \code{std_out} and \code{std_err}
types:
\itemize{
\item \emph{connection} a writable R \link{connection} object such as \link{stdout} or \link{stderr}
\item \emph{function}: callback function with one argument accepting a raw vector (use
\link{as_text} to convert to text).
}

When using \code{exec_background} with \code{std_out = TRUE} or \code{std_err = TRUE} on Windows,
separate threads are used to print output. This works in RStudio and RTerm but
not in RGui because the latter has a custom I/O mechanism. Directing output to a
file is usually the safest option.
}

\examples{
# Run a command (interrupt with CTRL+C)
status <- exec_wait("date")

# Capture std/out
out <- exec_internal("date")
print(out$status)
cat(as_text(out$stdout))

if(nchar(Sys.which("ping"))){

# Run a background process (daemon)
pid <- exec_background("ping", "localhost")

# Kill it after a while
Sys.sleep(2)
tools::pskill(pid)

# Cleans up the zombie proc
exec_status(pid)
rm(pid)
}
}
\seealso{
Base \link{system2} and \link{pipe} provide other methods for running a system
command with output.

Other sys: 
\code{\link{exec_r}}
}
\concept{sys}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/deprecated.R
\name{sys-deprecated}
\alias{sys-deprecated}
\alias{eval_safe}
\alias{eval_fork}
\title{Deprecated functions}
\usage{
eval_safe(...)

eval_fork(...)
}
\arguments{
\item{...}{see respective functions in the unix package}
}
\description{
These functions have moved into the \code{unix} package. Please update
your references.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/astext.R
\name{as_text}
\alias{as_text}
\title{Convert Raw to Text}
\usage{
as_text(x, ...)
}
\arguments{
\item{x}{vector to be converted to text}

\item{...}{parameters passed to \link{readLines} such as \code{encoding} or \code{n}}
}
\description{
Parses a raw vector as lines of text. This is similar to \link{charToRaw} but
splits output by (platform specific) linebreaks and allows for marking
output with a given encoding.
}
\seealso{
\link[base:rawConversion]{base::charToRaw}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/quote.R
\name{quote}
\alias{quote}
\alias{windows_quote}
\title{Quote arguments on Windows}
\usage{
windows_quote(args)
}
\arguments{
\item{args}{character vector with arguments}
}
\description{
Quotes and escapes shell arguments when needed so that they get properly parsed
by most Windows programs. This function is used internally to automatically quote
system commands, the user should normally not quote arguments manually.
}
\details{
Algorithm is ported to R from
\href{https://github.com/libuv/libuv/blob/v1.23.0/src/win/process.c#L454-L524}{libuv}.
}

# Generated by Pod::WikiDoc version 0.18

=pod

=head1 NAME

sys::process - Information about the currently running Perl interpreter.

=head1 VERSION

This document describes sys::process version v0.1

=head1 SYNOPSIS

     use sys::process;
 
 
     my $euid = sys::process->euid;
 
     sys::process->euid($new_value);
 
     my $uid = sys::process->uid;
 
     sys::process->uid($new_value);
 
     my $name = sys::process->name;
 
     sys::process->name($new_value);
 
     my $egid = sys::process->egid;
 
     sys::process->egid($new_value);
 
     my $pid = sys::process->pid;
 
     sys::process->pid($new_value);
 
     my $gid = sys::process->gid;
 
     sys::process->gid($new_value);

=head1 DESCRIPTION

This is the object oriented version of L<English>.

This module provides access to some objects used or maintained by
the interpreter and to functions that interact strongly with the interpreter.

=head1 SUBROUTINESE<sol>METHODS

=head2 CLASSE<sol>INSTANCE METHODS

=head3 C<<< euid($optional_new_value) >>>

Returns euid as a SCALAR.

=head3 C<<< uid($optional_new_value) >>>

Returns uid as a SCALAR.

=head3 C<<< name($optional_new_value) >>>

Returns name as a SCALAR.

=head3 C<<< egid($optional_new_value) >>>

Returns egid as a SCALAR.

=head3 C<<< pid($optional_new_value) >>>

Returns pid as a SCALAR.

=head3 C<<< gid($optional_new_value) >>>

Returns gid as a SCALAR.

=head1 DEPENDENCIES

=over

=item *

L<version>

=back

=over

=item *

L<Class::Dot>

=back

=over

=item *

L<Scalar::Util>

=back

=head1 INCOMPATIBILITIES

None known.

=head1 BUGS AND LIMITATIONS

No bugs have been reported.

Please report any bugs or feature requests to
L<bug-class-dot@rt.cpan.org|mailto:bug-class-dot@rt.cpan.org>, or through the
web interface at L<CPAN Bug tracker|http://rt.cpan.org>.

=head1 SEE ALSO

=over

=item *

L<perlvar>

=back

=over

=item *

L<English>

=back

=head1 AUTHOR

Ask Solem, L<asksh@cpan.org>.

=head1 LICENSE AND COPYRIGHT

Copyright (c), 2007 Ask Solem L<ask@0x61736b.net|mailto:ask@0x61736b.net>.

C<<< sys >>> is distributed under the Modified BSD License.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
this
list of conditions and the following disclaimer in the documentation andE<sol>or
other materials provided with the distribution.

3. The name of the author may not be used to endorse or promote products
derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED                        
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF                                
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO                          
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,                              
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,                        
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR                      
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER                       
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)                          
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE                          
POSSIBILITY OF SUCH DAMAGE.

=head1 DISCLAIMER OF WARRANTY

BECAUSE THIS SOFTWARE IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE
SOFTWARE, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE
STATED IN WRITING THE COPYRIGHT HOLDERS ANDE<sol>OR OTHER PARTIES PROVIDE THE
SOFTWARE "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE SOFTWARE IS WITH YOU. SHOULD THE SOFTWARE PROVE DEFECTIVE,
YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR CORRECTION.

IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY
COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY ANDE<sol>OR REDISTRIBUTE THE
SOFTWARE AS PERMITTED BY THE ABOVE LICENSE, BE LIABLE TO YOU FOR DAMAGES,
INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING
OUT OF THE USE OR INABILITY TO USE THE SOFTWARE (INCLUDING BUT NOT LIMITED TO
LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR
THIRD PARTIES OR A FAILURE OF THE SOFTWARE TO OPERATE WITH ANY OTHER
SOFTWARE), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGES.


=for stopwords expandtab shiftround
